/* cmd_neonserv_delme.c - NeonServ v5.6
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */

#include "cmd_neonserv.h"

/*
* argv[0] - key
*/

CMD_BIND(neonserv_cmd_delme) {
    MYSQL_RES *res;
    MYSQL_ROW row;
    int userid;
    printf_mysql_query("SELECT `user_id` FROM `users` WHERE `user_user` = '%s'", escape_string(user->auth));
    res = mysql_use();
    if ((row = mysql_fetch_row(res)) != NULL) {
        userid = atoi(row[0]);
        //check if the user is added
        printf_mysql_query("SELECT `chanuser_access`, `chanuser_id` FROM `chanusers` WHERE `chanuser_cid` = '%d' AND `chanuser_uid` = '%d'", chan->channel_id, userid);
        res = mysql_use();
        if ((row = mysql_fetch_row(res)) != NULL) {
            if(atoi(row[0]) == 500) {
                reply(textclient, user, "NS_DELME_OWNER", chan->name);
                return;
            }
            //check key
            int seed = 0;
            char *tmp;
            static char unregkey[16];
            for(tmp = user->auth; *tmp; tmp++)
                seed = (seed * 0xEECE66DL ^ ((*tmp << 24) | (*tmp << 16) | (*tmp << 8) | *tmp));
            for(tmp = chan->name; *tmp; tmp++)
                seed = (seed * 0xEECE66DL ^ ((*tmp << 24) | (*tmp << 16) | (*tmp << 8) | *tmp));
            sprintf(unregkey, "%08x", seed);
            if(argc < 1 || strcmp(argv[0], unregkey)) {
                reply(textclient, user, "NS_DELME_KEY", unregkey);
                return;
            } else {
                //delete
                printf_mysql_query("DELETE FROM `chanusers` WHERE `chanuser_id` = '%s'", row[1]);
                reply(textclient, user, "NS_DELME_DONE", atoi(row[0]), chan->name);
                logEvent(event);
                return;
            }
        }
    }
    reply(textclient, user, "NS_NOT_ON_USERLIST_YOU", chan->name);
}
